package cz.muni.fi.pb162.intf;

/**
 * DogName is a simple demo interface providing three methods
 * and one static method.
 * fullName() - returns full name of dog containing
 * both given- and kennel- name
 */
public interface DogName {
    // static variable possible
    // it will be available in all classes implementing this intf.
    static final String TITLE = "Dog overview:";

    // for any classes implementing this intf. it is enough
    // to implement just these two abstract methods
    String givenName();

    String kennelName();

    // default method - it can still be overridden in implementing classes
    default String fullName() {
        return givenName() + " " + kennelName();
    }

    // static method available using DogName.printOverview
    // but NOT in all classes implementing this intf!
    // ie you cannot write dog.printOverview!
    static void printOverview(DogName... names) {
        System.out.println(TITLE);
        for(DogName n: names)
            System.out.println("  " + n.fullName());
    }
}